# coding: utf-8

"""
Copyright (c) 2019 Aspose.Cells Cloud
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
"""


from pprint import pformat
from six import iteritems
import re


class ObjectExist(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'exists': 'bool',
        'is_folder': 'bool'
    }

    attribute_map = {
        'exists': 'Exists',
        'is_folder': 'IsFolder'
    }
    
    @staticmethod
    def get_swagger_types():
        return ObjectExist.swagger_types
    
    @staticmethod
    def get_attribute_map():
        return ObjectExist.attribute_map
    
    def get_from_container(self, attr):
        if attr in self.container:
            return self.container[attr]
        return None

    def __init__(self, exists=None, is_folder=None, **kw):
        """
        Associative dict for storing property values
        """
        self.container = {}
		    
        """
        ObjectExist - a model defined in Swagger
        """

        self.container['exists'] = None
        self.container['is_folder'] = None

        self.exists = exists
        self.is_folder = is_folder

    @property
    def exists(self):
        """
        Gets the exists of this ObjectExist.
        Indicates that the file or folder exists.

        :return: The exists of this ObjectExist.
        :rtype: bool
        """
        return self.container['exists']

    @exists.setter
    def exists(self, exists):
        """
        Sets the exists of this ObjectExist.
        Indicates that the file or folder exists.

        :param exists: The exists of this ObjectExist.
        :type: bool
        """
        """
        if exists is None:
            raise ValueError("Invalid value for `exists`, must not be `None`")
        """

        self.container['exists'] = exists

    @property
    def is_folder(self):
        """
        Gets the is_folder of this ObjectExist.
        True if it is a folder, false if it is a file.

        :return: The is_folder of this ObjectExist.
        :rtype: bool
        """
        return self.container['is_folder']

    @is_folder.setter
    def is_folder(self, is_folder):
        """
        Sets the is_folder of this ObjectExist.
        True if it is a folder, false if it is a file.

        :param is_folder: The is_folder of this ObjectExist.
        :type: bool
        """
        """
        if is_folder is None:
            raise ValueError("Invalid value for `is_folder`, must not be `None`")
        """

        self.container['is_folder'] = is_folder

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.get_swagger_types()):
            value = self.get_from_container(attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ObjectExist):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
